diff -ruN vdr-1.7.23/CONTRIBUTORS vdr-1.7.24/CONTRIBUTORS
--- vdr-1.7.23/CONTRIBUTORS	2012-01-15 15:23:20.000000000 +0100
+++ vdr-1.7.24/CONTRIBUTORS	2012-02-19 12:50:20.000000000 +0100
@@ -272,6 +272,8 @@
  for helping to test new DVB-T handling
  for reporting a bug in switching the video format in the Setup/DVB menu
  for reporting a problem with frozen live view in conjunction with device bonding
+ for reporting a problem in handling the PrimaryLimit when requesting a device for
+ live viewing
 
 Matjaz Thaler <matjaz.thaler@guest.arnes.si>
  for improving AC3 decoding when replaying DVDs
@@ -604,6 +606,7 @@
  for a patch that was used to implement the command line options --edit and
  --genindex
  for suggesting to disable EPG processing for a while after a CLRE command
+ for suggesting to read the epg.data file in a separate thread
 
 Jeremy Hall <jhall@UU.NET>
  for fixing an incomplete initialization of the filter parameters in eit.c
@@ -680,6 +683,7 @@
  for his input on calculating the Aspect factor in GetOsdSize()
  for suggesting a better way of handling calls to realloc()
  for making the cutter set the 'broken link' flag for MPEG2 TS recordings
+ for reporting a crash in a plugin using cDeviceHook when VDR ends
 
 Reinhard Walter Buchner <rw.buchner@freenet.de>
  for adding some satellites to 'sources.conf'
@@ -1125,6 +1129,7 @@
  for adding support for DVB-T2 to libsi
  for adding support for handling DVB-T2 transponders
  for suggesting to add member functions Adapter() and Frontend() to cDvbDevice
+ for improving handling subtitles of BBC channels
 
 Ralf Klueber <ralf.klueber@vodafone.com>
  for reporting a bug in cutting a recording if there is only a single editing mark
@@ -1293,6 +1298,7 @@
  for making subtitle PIDs be decrypted
  for making cEITScanner process new transponders before old ones, to make sure
  transponder changes are recognized
+ for helping to debug switching into time shift mode when pausing live video
 
 Richard Robson <richard_robson@beeb.net>
  for reporting freezing replay if a timer starts while in Transfer Mode from the
@@ -1765,6 +1771,7 @@
  for adding a missing 'const' to cRecording::FramesPerSecond()
  for modifying cCharSetConv so that it can be used to convert from "whatever VDR uses"
  to a given code
+ for adding some missing 'const' to cDevice
 
 Sascha Klek <sklek@gmx.de>
  for reporting a problem with the '0' key in the "Day" item of the "Timers" menu
@@ -2267,6 +2274,8 @@
  index file
  for fixing setting the start time of an edited recording
  for adding support for HbbTV to libsi
+ for fixing cRecording::LengthInSeconds(), which wrongfully rounded the result to full
+ minutes
 
 Pekka Mauno <pekka.mauno@iki.fi>
  for fixing cSchedule::GetFollowingEvent() in case there is currently no present
@@ -2816,3 +2825,16 @@
  of EPG data from BSkyB's "MTV MUSIC"
  for suggesting to make BIDI support check at runtime whether the system runs with
  UTF-8
+
+Christian Ruppert <idl0r@gentoo.org>
+ for some improvements to the Makefiles
+
+Ralf Schueler <dl4mw@schueler.ws>
+ for backporting "Changed cDvbDevice::GrabImage() to use V4L" from version 1.7.3
+ to 1.6.0-3
+ for backporting "Added some missing 'const' keywords to avoid compilation errors
+ with gcc 4.4" from version 1.7.8 to 1.6.0-3
+ for backporting "Modified cSVDRP::CmdGRAB() to avoid writing into const data"
+ from version 1.7.8 to 1.6.0-3
+ for backporting "Fixed cRecordings::DelByName() to avoid compilation errors with
+ gcc 4.4" from version 1.7.9 to 1.6.0-3
diff -ruN vdr-1.7.23/HISTORY vdr-1.7.24/HISTORY
--- vdr-1.7.23/HISTORY	2012-01-15 15:26:54.000000000 +0100
+++ vdr-1.7.24/HISTORY	2012-02-19 12:49:32.000000000 +0100
@@ -6835,3 +6835,56 @@
   progress display.
 - Fixed frozen live view with device bonding in case the bonded master is used for
   live viewing (reported by Uwe Scheffler).
+
+2012-02-14: Version 1.6.0-3
+
+- Changed cDvbDevice::GrabImage() to use V4L2
+  (backport from version 1.7.3, thanks to Ralf Schueler).
+- Added some missing 'const' keywords to avoid compilation errors with gcc 4.4
+  (backport from version 1.7.8, thanks to Ralf Schueler).
+- Modified cSVDRP::CmdGRAB() to avoid writing into const data
+  (backport from version 1.7.8, thanks to Ralf Schueler).
+- Fixed cRecordings::DelByName() to avoid compilation errors with gcc 4.4
+  (backport from version 1.7.9, thanks to Ralf Schueler).
+
+2012-02-19: Version 1.7.24
+
+- Updated the Italian OSD texts (thanks to Diego Pierotto).
+- Fixed a high load in case a transponder can't be received.
+- Improved the way DVB_API_VERSION is checked.
+- Updated the Finnish OSD texts (thanks to Rolf Ahrenberg).
+- Fixed asserting there is a live programme if the primary device is bonded with
+  a device that starts a recording on a different band.
+- Fixed the return type of cMyDeviceHook::DeviceProvidesTransponder() in PLUGINS.html.
+- Fixed a crash in a plugin using cDeviceHook when VDR ends (reported by Oliver Endriss).
+- Some improvements to the Makefiles (thanks to Christian Ruppert).
+- Fixed cRecording::LengthInSeconds(), which wrongfully rounded the result to full
+  minutes (thanks to Christoph Haubrich).
+- Symbolic links are no longer resolved in cRecordings::ScanVideoDir() (thanks to
+  Sundararaj Reel).
+- The epg.data file is now read in a separate thread to make the startup process
+  faster in case the file is very large (suggested by Helmut Auer).
+- Fixed selecting the primary device for receiving the live viewing channel in
+  case it is bonded with an other device and has no receiver attached to it.
+- Fixed a possible crash when canceling VDR while displaying subtitles, and the
+  primary device is no longer available.
+- Improved handling subtitles of BBC channels.
+- No longer using tabs as delimiter in the EPG bugfix log (they were garbled in the
+  log file).
+- Added a missing '.' after the month in VPS strings.
+- Added some missing 'const' to cDevice (thanks to Joachim Wilke).
+- Fixed handling the PrimaryLimit when requesting a device for live viewing
+  (reported by Uwe Scheffler).
+- Removed superfluous calls to SetVideoFormat() from device constructors. This
+  function is called in cDevice::SetPrimaryDevice(), anyway.
+- An ongoing editing process is now canceled if either the original or the edited
+  version of the recording is deleted from the Recordings menu.
+- The SVDRP command DELR now won't delete a recording that is currently being edited.
+- Removed code stub for obsolete SVDRP command MOVT.
+- The DVB device adapters/frontends are now probed by scanning the /dev/dvb directory
+  instead of looping through adapter/frontend numbers. This allows for "holes" in the
+  device numbering.
+- cReadDir::Next() now skips directory entries "." and "..".
+- Fixed a possible deadlock in time shift mode.
+- Fixed switching into time shift mode when pausing live video (thanks to Reinhard
+  Nissl for helping to debug this one).
diff -ruN vdr-1.7.23/INSTALL vdr-1.7.24/INSTALL
--- vdr-1.7.23/INSTALL	2011-11-27 11:37:54.000000000 +0100
+++ vdr-1.7.24/INSTALL	2012-02-16 11:23:32.000000000 +0100
@@ -304,7 +304,7 @@
 Note that the file system need not be 64-bit proof, since the 'vdr'
 program splits video files into chunks of about 2GB. You should use
 a disk with several gigabytes of free space. One GB can store roughly
-half an hour of video data.
+half an hour of SD video data, or 10 minutes of HD video.
 
 If you have more than one disk and don't want to combine them to form
 one large logical volume, you can set up several video directories as
diff -ruN vdr-1.7.23/Make.config.template vdr-1.7.24/Make.config.template
--- vdr-1.7.23/Make.config.template	2011-12-04 15:41:00.000000000 +0100
+++ vdr-1.7.24/Make.config.template	2012-01-18 13:20:51.000000000 +0100
@@ -6,15 +6,15 @@
 # See the main source file 'vdr.c' for copyright information and
 # how to reach the author.
 #
-# $Id: Make.config.template 2.4 2011/12/04 14:41:00 kls Exp $
+# $Id: Make.config.template 2.5 2012/01/18 12:20:51 kls Exp $
 
 ### The C compiler and options:
 
-CC       = gcc
-CFLAGS   = -g -O3 -Wall
+CC       ?= gcc
+CFLAGS   ?= -g -O3 -Wall
 
-CXX      = g++
-CXXFLAGS = -g -O3 -Wall -Woverloaded-virtual -Wno-parentheses
+CXX      ?= g++
+CXXFLAGS ?= -g -O3 -Wall -Woverloaded-virtual -Wno-parentheses
 
 ifdef PLUGIN
 CFLAGS   += -fPIC
@@ -23,23 +23,24 @@
 
 ### The directory environment:
 
-#DVBDIR   = /usr/src/v4l-dvb/linux
-MANDIR   = /usr/local/man
-BINDIR   = /usr/local/bin
-
-LOCDIR   = ./locale
-PLUGINDIR= ./PLUGINS
-PLUGINLIBDIR= $(PLUGINDIR)/lib
-VIDEODIR = /video
-CONFDIR  = $(VIDEODIR)
+PREFIX   ?= $(DESTDIR)/usr/local
+#DVBDIR   ?= /usr/src/v4l-dvb/linux
+MANDIR   ?= $(PREFIX)/man
+BINDIR   ?= $(PREFIX)/bin
+
+LOCDIR       ?= ./locale
+PLUGINDIR    ?= ./PLUGINS
+PLUGINLIBDIR ?= $(PLUGINDIR)/lib
+VIDEODIR     ?= /video
+CONFDIR      ?= $(VIDEODIR)
 
 ### The remote control:
 
-LIRC_DEVICE = /var/run/lirc/lircd
-RCU_DEVICE  = /dev/ttyS1
+LIRC_DEVICE ?= /var/run/lirc/lircd
+RCU_DEVICE  ?= /dev/ttyS1
 
 ## Define if you want vdr to not run as root
-#VDR_USER = vdr
+#VDR_USER ?= vdr
 
 ### You don't need to touch the following:
 
diff -ruN vdr-1.7.23/Makefile vdr-1.7.24/Makefile
--- vdr-1.7.23/Makefile	2012-01-14 14:09:10.000000000 +0100
+++ vdr-1.7.24/Makefile	2012-01-18 13:19:37.000000000 +0100
@@ -4,7 +4,7 @@
 # See the main source file 'vdr.c' for copyright information and
 # how to reach the author.
 #
-# $Id: Makefile 2.23 2012/01/14 13:09:10 kls Exp $
+# $Id: Makefile 2.24 2012/01/18 12:19:37 kls Exp $
 
 .DELETE_ON_ERROR:
 
@@ -17,10 +17,10 @@
 LSIDIR   = ./libsi
 DESTDIR ?=
 PREFIX  ?= /usr/local
-MANDIR   = $(PREFIX)/share/man
-BINDIR   = $(PREFIX)/bin
-INCDIR   = $(PREFIX)/include
-LOCDIR   = ./locale
+MANDIR  ?= $(PREFIX)/share/man
+BINDIR  ?= $(PREFIX)/bin
+INCDIR  ?= $(PREFIX)/include
+LOCDIR  ?= ./locale
 LIBS     = -ljpeg -lpthread -ldl -lcap -lrt $(shell pkg-config --libs freetype2 fontconfig)
 INCLUDES ?= $(shell pkg-config --cflags freetype2 fontconfig)
 
@@ -30,7 +30,7 @@
 VIDEODIR = /video
 CONFDIR  = $(VIDEODIR)
 
-DOXYGEN  = /usr/bin/doxygen
+DOXYGEN ?= /usr/bin/doxygen
 DOXYFILE = Doxyfile
 
 PCDIR   ?= $(firstword $(subst :, , ${PKG_CONFIG_PATH}:$(shell pkg-config --variable=pc_path pkg-config):$(PREFIX)/lib/pkgconfig))
@@ -246,4 +246,3 @@
 	-rm -rf include
 	-rm -rf srcdoc
 CLEAN: clean
-
diff -ruN vdr-1.7.23/PLUGINS/src/dvbhddevice/Makefile vdr-1.7.24/PLUGINS/src/dvbhddevice/Makefile
--- vdr-1.7.23/PLUGINS/src/dvbhddevice/Makefile	2011-12-04 16:30:21.000000000 +0100
+++ vdr-1.7.24/PLUGINS/src/dvbhddevice/Makefile	2012-02-08 16:10:09.000000000 +0100
@@ -1,7 +1,7 @@
 #
 # Makefile for a Video Disk Recorder plugin
 #
-# $Id: Makefile 1.9 2011/12/04 15:30:21 kls Exp $
+# $Id: Makefile 1.12 2012/02/08 15:10:09 kls Exp $
 
 # The official name of this plugin.
 # This name will be used in the '-P...' option of VDR to load the plugin.
@@ -22,9 +22,9 @@
 
 ### The directory environment:
 
-VDRDIR = ../../..
-LIBDIR = ../../lib
-TMPDIR = /tmp
+VDRDIR ?= ../../..
+LIBDIR ?= ../../lib
+TMPDIR ?= /tmp
 
 ### Make sure that necessary options are included:
 
@@ -51,7 +51,7 @@
 
 ### The object files (add further files here):
 
-OBJS = $(PLUGIN).o bitbuffer.o dvbhdffdevice.o hdffcmd.o hdffosd.o setup.o
+OBJS = $(PLUGIN).o dvbhdffdevice.o hdffcmd.o hdffosd.o menu.o setup.o
 
 ### The main target:
 
diff -ruN vdr-1.7.23/PLUGINS/src/dvbhddevice/dvbhddevice.c vdr-1.7.24/PLUGINS/src/dvbhddevice/dvbhddevice.c
--- vdr-1.7.23/PLUGINS/src/dvbhddevice/dvbhddevice.c	2011-08-27 11:31:45.000000000 +0200
+++ vdr-1.7.24/PLUGINS/src/dvbhddevice/dvbhddevice.c	2012-02-08 16:10:30.000000000 +0100
@@ -3,29 +3,37 @@
  *
  * See the README file for copyright information and how to reach the author.
  *
- * $Id: dvbhddevice.c 1.14 2011/08/27 09:31:45 kls Exp $
+ * $Id: dvbhddevice.c 1.16 2012/02/08 15:10:30 kls Exp $
  */
 
 #include <vdr/plugin.h>
+#include <vdr/shutdown.h>
 #include "dvbhdffdevice.h"
+#include "menu.h"
 #include "setup.h"
 
 static const char *VERSION        = "0.0.4";
 static const char *DESCRIPTION    = trNOOP("HD Full Featured DVB device");
+static const char *MAINMENUENTRY  = "dvbhddevice";
 
 class cPluginDvbhddevice : public cPlugin {
 private:
   cDvbHdFfDeviceProbe *probe;
+  bool mIsUserInactive;
 public:
   cPluginDvbhddevice(void);
   virtual ~cPluginDvbhddevice();
   virtual const char *Version(void) { return VERSION; }
   virtual const char *Description(void) { return tr(DESCRIPTION); }
+  virtual void MainThreadHook(void);
+  virtual const char *MainMenuEntry(void);
+  virtual cOsdObject *MainMenuAction(void);
   virtual cMenuSetupPage *SetupMenu(void);
   virtual bool SetupParse(const char *Name, const char *Value);
   };
 
 cPluginDvbhddevice::cPluginDvbhddevice(void)
+:   mIsUserInactive(true)
 {
   probe = new cDvbHdFfDeviceProbe;
 }
@@ -35,6 +43,33 @@
   delete probe;
 }
 
+void cPluginDvbhddevice::MainThreadHook(void)
+{
+    bool isUserInactive = ShutdownHandler.IsUserInactive();
+    if (isUserInactive != mIsUserInactive)
+    {
+        mIsUserInactive = isUserInactive;
+        if (gHdffSetup.CecEnabled && gHdffSetup.CecTvOn)
+        {
+            HDFF::cHdffCmdIf * hdffCmdIf = cDvbHdFfDevice::GetHdffCmdHandler();
+            if (!mIsUserInactive)
+            {
+                hdffCmdIf->CmdHdmiSendCecCommand(HDFF_CEC_COMMAND_TV_ON);
+            }
+        }
+    }
+}
+
+const char *cPluginDvbhddevice::MainMenuEntry(void)
+{
+  return gHdffSetup.HideMainMenu ? NULL : MAINMENUENTRY;
+}
+
+cOsdObject *cPluginDvbhddevice::MainMenuAction(void)
+{
+  return new cHdffMenu(cDvbHdFfDevice::GetHdffCmdHandler());
+}
+
 cMenuSetupPage *cPluginDvbhddevice::SetupMenu(void)
 {
   return new cHdffSetupPage(cDvbHdFfDevice::GetHdffCmdHandler());
diff -ruN vdr-1.7.23/PLUGINS/src/dvbhddevice/dvbhdffdevice.c vdr-1.7.24/PLUGINS/src/dvbhddevice/dvbhdffdevice.c
--- vdr-1.7.23/PLUGINS/src/dvbhddevice/dvbhdffdevice.c	2011-12-04 16:30:42.000000000 +0100
+++ vdr-1.7.24/PLUGINS/src/dvbhddevice/dvbhdffdevice.c	2012-02-15 14:14:49.000000000 +0100
@@ -3,9 +3,11 @@
  *
  * See the README file for copyright information and how to reach the author.
  *
- * $Id: dvbhdffdevice.c 1.35 2011/12/04 15:30:42 kls Exp $
+ * $Id: dvbhdffdevice.c 1.39 2012/02/15 13:14:49 kls Exp $
  */
 
+#include <stdint.h>
+
 #include "dvbhdffdevice.h"
 #include <errno.h>
 #include <limits.h>
@@ -50,30 +52,34 @@
      mHdffCmdIf->CmdAvSetAudioDownmix((HdffAudioDownmixMode_t) gHdffSetup.AudioDownmix);
      mHdffCmdIf->CmdMuxSetVideoOut((HdffVideoOut_t) gHdffSetup.AnalogueVideo);
      mHdffCmdIf->CmdHdmiSetVideoMode(gHdffSetup.GetVideoMode());
+
      HdffHdmiConfig_t hdmiConfig;
+     memset(&hdmiConfig, 0, sizeof(hdmiConfig));
      hdmiConfig.TransmitAudio = true;
      hdmiConfig.ForceDviMode = false;
      hdmiConfig.CecEnabled = gHdffSetup.CecEnabled;
+     strcpy(hdmiConfig.CecDeviceName, "VDR");
      hdmiConfig.VideoModeAdaption = (HdffVideoModeAdaption_t) gHdffSetup.VideoModeAdaption;
      mHdffCmdIf->CmdHdmiConfigure(&hdmiConfig);
-     if (gHdffSetup.CecEnabled)
-        mHdffCmdIf->CmdHdmiSendCecCommand(HDFF_CEC_COMMAND_TV_ON);
+
      mHdffCmdIf->CmdRemoteSetProtocol((HdffRemoteProtocol_t) gHdffSetup.RemoteProtocol);
      mHdffCmdIf->CmdRemoteSetAddressFilter(gHdffSetup.RemoteAddress >= 0, gHdffSetup.RemoteAddress);
      }
-
-  // Video format:
-
-  SetVideoFormat(Setup.VideoFormat);
 }
 
 cDvbHdFfDevice::~cDvbHdFfDevice()
 {
-  delete spuDecoder;
-  if (isHdffPrimary)
-     delete mHdffCmdIf;
-  // We're not explicitly closing any device files here, since this sometimes
-  // caused segfaults. Besides, the program is about to terminate anyway...
+    delete spuDecoder;
+    if (isHdffPrimary)
+    {
+        if (gHdffSetup.CecEnabled && gHdffSetup.CecTvOff)
+        {
+            mHdffCmdIf->CmdHdmiSendCecCommand(HDFF_CEC_COMMAND_TV_OFF);
+        }
+        delete mHdffCmdIf;
+    }
+    // We're not explicitly closing any device files here, since this sometimes
+    // caused segfaults. Besides, the program is about to terminate anyway...
 }
 
 void cDvbHdFfDevice::MakePrimaryDevice(bool On)
diff -ruN vdr-1.7.23/PLUGINS/src/dvbhddevice/hdffcmd.c vdr-1.7.24/PLUGINS/src/dvbhddevice/hdffcmd.c
--- vdr-1.7.23/PLUGINS/src/dvbhddevice/hdffcmd.c	2011-12-04 16:31:03.000000000 +0100
+++ vdr-1.7.24/PLUGINS/src/dvbhddevice/hdffcmd.c	2012-02-06 12:08:48.000000000 +0100
@@ -3,9 +3,11 @@
  *
  * See the README file for copyright information and how to reach the author.
  *
- * $Id: hdffcmd.c 1.22 2011/12/04 15:31:03 kls Exp $
+ * $Id: hdffcmd.c 1.23 2012/02/06 11:08:48 kls Exp $
  */
 
+#include <stdint.h>
+
 #include "hdffcmd.h"
 #include "libhdffcmd/hdffcmd.h"
 #include <stdio.h>
diff -ruN vdr-1.7.23/PLUGINS/src/dvbhddevice/hdffcmd.h vdr-1.7.24/PLUGINS/src/dvbhddevice/hdffcmd.h
--- vdr-1.7.23/PLUGINS/src/dvbhddevice/hdffcmd.h	2011-12-04 16:31:23.000000000 +0100
+++ vdr-1.7.24/PLUGINS/src/dvbhddevice/hdffcmd.h	2012-02-06 12:09:27.000000000 +0100
@@ -3,13 +3,12 @@
  *
  * See the README file for copyright information and how to reach the author.
  *
- * $Id: hdffcmd.h 1.18 2011/12/04 15:31:23 kls Exp $
+ * $Id: hdffcmd.h 1.19 2012/02/06 11:09:27 kls Exp $
  */
 
 #ifndef _HDFF_CMD_H_
 #define _HDFF_CMD_H_
 
-#include "bitbuffer.h"
 #include "libhdffcmd/hdffcmd.h"
 
 namespace HDFF
diff -ruN vdr-1.7.23/PLUGINS/src/dvbhddevice/libhdffcmd/Makefile vdr-1.7.24/PLUGINS/src/dvbhddevice/libhdffcmd/Makefile
--- vdr-1.7.23/PLUGINS/src/dvbhddevice/libhdffcmd/Makefile	2011-10-16 17:12:49.000000000 +0200
+++ vdr-1.7.24/PLUGINS/src/dvbhddevice/libhdffcmd/Makefile	2012-01-18 13:25:20.000000000 +0100
@@ -4,17 +4,9 @@
 
 VERSION = 0.1.0
 
-ifndef $(INSTALL_PATH)
-    INSTALL_PATH=/usr/local
-endif
-
-ifndef $(INSTALL_LIB_PATH)
-    INSTALL_LIB_PATH=$(INSTALL_PATH)/lib
-endif
-
-ifndef $(INSTALL_INCLUDE_PATH)
-    INSTALL_INCLUDE_PATH=$(INSTALL_PATH)/include
-endif
+INSTALL_PATH         ?= /usr/local
+INSTALL_LIB_PATH     ?= $(INSTALL_PATH)/lib
+INSTALL_INCLUDE_PATH ?= $(INSTALL_PATH)/include
 
 LIB_NAME = libhdffcmd
 
@@ -27,9 +19,10 @@
 LIB_STATIC = $(LIB_NAME).a
 LIB_SHARED = $(LIB_NAME)-$(VERSION).so
 
-CC     = gcc
-CFLAGS = -g -O2 -fPIC -Wall
-AR     = ar -r
+CC      ?= gcc
+CFLAGS  ?= -g -O2 -fPIC -Wall
+AR      ?= ar
+ARFLAGS ?= r
 
 ### Implicit rules:
 
@@ -50,10 +43,10 @@
 all: $(LIB_STATIC) $(LIB_SHARED)
 
 $(LIB_STATIC): $(LIB_OBJS)
-	$(AR) $(LIB_STATIC) $(LIB_OBJS)
+	$(AR) $(ARFLAGS) $(LIB_STATIC) $(LIB_OBJS)
 
 $(LIB_SHARED): $(LIB_OBJS)
-	$(CC) -fPIC -shared -o $(LIB_SHARED) $(LIB_OBJS)
+	$(CC) $(CFLAGS) $(LDFLAGS) -fPIC -shared -o $(LIB_SHARED) $(LIB_OBJS)
 	ln -sf $(LIB_SHARED) $(LIB_NAME).so
 
 clean:
diff -ruN vdr-1.7.23/PLUGINS/src/dvbhddevice/libhdffcmd/hdffcmd_av.h vdr-1.7.24/PLUGINS/src/dvbhddevice/libhdffcmd/hdffcmd_av.h
--- vdr-1.7.23/PLUGINS/src/dvbhddevice/libhdffcmd/hdffcmd_av.h	2011-10-16 17:12:49.000000000 +0200
+++ vdr-1.7.24/PLUGINS/src/dvbhddevice/libhdffcmd/hdffcmd_av.h	2012-02-05 20:25:33.000000000 +0100
@@ -66,7 +66,8 @@
     HDFF_VIDEO_CONVERSION_LETTERBOX_14_BY_9,
     HDFF_VIDEO_CONVERSION_PILLARBOX,
     HDFF_VIDEO_CONVERSION_CENTRE_CUT_OUT,
-    HDFF_VIDEO_CONVERSION_ALWAYS_16_BY_9
+    HDFF_VIDEO_CONVERSION_ALWAYS_16_BY_9,
+    HDFF_VIDEO_CONVERSION_ZOOM_16_BY_9
 } HdffVideoConversion_t;
 
 typedef struct HdffVideoFormat_t
diff -ruN vdr-1.7.23/PLUGINS/src/dvbhddevice/libhdffcmd/hdffcmd_defs.h vdr-1.7.24/PLUGINS/src/dvbhddevice/libhdffcmd/hdffcmd_defs.h
--- vdr-1.7.23/PLUGINS/src/dvbhddevice/libhdffcmd/hdffcmd_defs.h	2011-10-16 17:12:49.000000000 +0200
+++ vdr-1.7.24/PLUGINS/src/dvbhddevice/libhdffcmd/hdffcmd_defs.h	2012-02-05 20:25:33.000000000 +0100
@@ -111,6 +111,7 @@
     HDFF_MSG_HDMI_GET_DISPLAY_INFO,
     HDFF_MSG_HDMI_GET_VIDEO_MODE,
     HDFF_MSG_HDMI_SEND_CEC_COMMAND,
+    HDFF_MSG_HDMI_SEND_RAW_CEC_COMMAND,
 
     HDFF_MSG_REMOTE_SET_PROTOCOL = 0,
     HDFF_MSG_REMOTE_SET_ADDRESS_FILTER,
diff -ruN vdr-1.7.23/PLUGINS/src/dvbhddevice/libhdffcmd/hdffcmd_hdmi.c vdr-1.7.24/PLUGINS/src/dvbhddevice/libhdffcmd/hdffcmd_hdmi.c
--- vdr-1.7.23/PLUGINS/src/dvbhddevice/libhdffcmd/hdffcmd_hdmi.c	2011-10-16 17:12:49.000000000 +0200
+++ vdr-1.7.24/PLUGINS/src/dvbhddevice/libhdffcmd/hdffcmd_hdmi.c	2012-02-05 20:25:33.000000000 +0100
@@ -48,9 +48,11 @@
 
 int HdffCmdHdmiConfigure(int OsdDevice, const HdffHdmiConfig_t * Config)
 {
-    uint8_t cmdData[8];
+    uint8_t cmdData[24];
     BitBuffer_t cmdBuf;
     osd_raw_cmd_t osd_cmd;
+    size_t nameLen;
+    int i;
 
     BitBuffer_Init(&cmdBuf, cmdData, sizeof(cmdData));
     memset(&osd_cmd, 0, sizeof(osd_raw_cmd_t));
@@ -61,6 +63,14 @@
     BitBuffer_SetBits(&cmdBuf, 1, Config->ForceDviMode ? 1 : 0);
     BitBuffer_SetBits(&cmdBuf, 1, Config->CecEnabled ? 1 : 0);
     BitBuffer_SetBits(&cmdBuf, 3, Config->VideoModeAdaption);
+    BitBuffer_SetBits(&cmdBuf, 6, 0); // reserved
+    nameLen = strlen(Config->CecDeviceName);
+    if (nameLen > 13)
+        nameLen = 13;
+    BitBuffer_SetBits(&cmdBuf, 4, nameLen);
+    for (i = 0; i < nameLen; i++)
+        BitBuffer_SetBits(&cmdBuf, 8, Config->CecDeviceName[i]);
+
     osd_cmd.cmd_len = HdffCmdSetLength(&cmdBuf);
     return ioctl(OsdDevice, OSD_RAW_CMD, &osd_cmd);
 }
@@ -80,3 +90,31 @@
     osd_cmd.cmd_len = HdffCmdSetLength(&cmdBuf);
     return ioctl(OsdDevice, OSD_RAW_CMD, &osd_cmd);
 }
+
+int HdffCmdHdmiSendRawCecCommand(int OsdDevice, uint8_t Destination,
+                                 uint8_t Opcode, const uint8_t * Operand,
+                                 uint8_t OperandLength)
+{
+    uint8_t cmdData[24];
+    BitBuffer_t cmdBuf;
+    osd_raw_cmd_t osd_cmd;
+    int i;
+
+    if (OperandLength > 14)
+        OperandLength = 14;
+
+    BitBuffer_Init(&cmdBuf, cmdData, sizeof(cmdData));
+    memset(&osd_cmd, 0, sizeof(osd_raw_cmd_t));
+    osd_cmd.cmd_data = cmdData;
+    HdffCmdBuildHeader(&cmdBuf, HDFF_MSG_TYPE_COMMAND, HDFF_MSG_GROUP_HDMI,
+                       HDFF_MSG_HDMI_SEND_RAW_CEC_COMMAND);
+    BitBuffer_SetBits(&cmdBuf, 4, 0); // reserved
+    BitBuffer_SetBits(&cmdBuf, 4, Destination);
+    BitBuffer_SetBits(&cmdBuf, 8, Opcode);
+    BitBuffer_SetBits(&cmdBuf, 8, OperandLength);
+    for (i = 0; i < OperandLength; i++)
+        BitBuffer_SetBits(&cmdBuf, 8, Operand[i]);
+
+    osd_cmd.cmd_len = HdffCmdSetLength(&cmdBuf);
+    return ioctl(OsdDevice, OSD_RAW_CMD, &osd_cmd);
+}
diff -ruN vdr-1.7.23/PLUGINS/src/dvbhddevice/libhdffcmd/hdffcmd_hdmi.h vdr-1.7.24/PLUGINS/src/dvbhddevice/libhdffcmd/hdffcmd_hdmi.h
--- vdr-1.7.23/PLUGINS/src/dvbhddevice/libhdffcmd/hdffcmd_hdmi.h	2011-10-16 17:12:49.000000000 +0200
+++ vdr-1.7.24/PLUGINS/src/dvbhddevice/libhdffcmd/hdffcmd_hdmi.h	2012-02-07 20:29:05.000000000 +0100
@@ -47,14 +47,15 @@
     int ForceDviMode;
     int CecEnabled;
     HdffVideoModeAdaption_t VideoModeAdaption;
+    char CecDeviceName[14];
 } HdffHdmiConfig_t;
 
 typedef enum HdffCecCommand_t
 {
     HDFF_CEC_COMMAND_TV_ON,
     HDFF_CEC_COMMAND_TV_OFF,
-    HDFF_CEC_COMMAND_TV_ACTIVE_SOURCE,
-    HDFF_CEC_COMMAND_TV_INACTIVE_SOURCE
+    HDFF_CEC_COMMAND_ACTIVE_SOURCE,
+    HDFF_CEC_COMMAND_INACTIVE_SOURCE
 } HdffCecCommand_t;
 
 
@@ -64,4 +65,8 @@
 
 int HdffCmdHdmiSendCecCommand(int OsdDevice, HdffCecCommand_t Command);
 
+int HdffCmdHdmiSendRawCecCommand(int OsdDevice, uint8_t Destination,
+                                 uint8_t Opcode, const uint8_t * Operand,
+                                 uint8_t OperandLength);
+
 #endif /* HDFFCMD_HDMI_H */
diff -ruN vdr-1.7.23/PLUGINS/src/dvbhddevice/menu.c vdr-1.7.24/PLUGINS/src/dvbhddevice/menu.c
--- vdr-1.7.23/PLUGINS/src/dvbhddevice/menu.c	1970-01-01 01:00:00.000000000 +0100
+++ vdr-1.7.24/PLUGINS/src/dvbhddevice/menu.c	2012-02-07 20:29:05.000000000 +0100
@@ -0,0 +1,65 @@
+/*
+ * menu.c: The DVB HD Full Featured device main menu
+ *
+ * See the README file for copyright information and how to reach the author.
+ */
+
+#include "menu.h"
+#include "setup.h"
+
+cHdffMenu::cHdffMenu(HDFF::cHdffCmdIf * pHdffCmdIf)
+:   cOsdMenu("dvbhddevice"),
+    mHdffCmdIf(pHdffCmdIf)
+{
+    mVideoConversionItem = new cOsdItem("", osUnknown, false);
+    Add(mVideoConversionItem);
+    SetHelp(tr("Video Conversion"), tr("TV on"));
+    SetVideoConversion();
+}
+
+cHdffMenu::~cHdffMenu()
+{
+}
+
+eOSState cHdffMenu::ProcessKey(eKeys key)
+{
+    eOSState state = cOsdMenu::ProcessKey(key);
+    if (state == osUnknown)
+    {
+        switch (key)
+        {
+            case kRed:
+                gHdffSetup.SetNextVideoConversion();
+                SetVideoConversion();
+                break;
+
+            case kGreen:
+                mHdffCmdIf->CmdHdmiSendCecCommand(HDFF_CEC_COMMAND_TV_ON);
+                state = osEnd;
+                break;
+
+            case kOk:
+                state = osEnd;
+                break;
+
+            default:
+                break;
+        }
+    }
+    return state;
+}
+
+void cHdffMenu::SetVideoConversion(void)
+{
+    HdffVideoFormat_t videoFormat;
+    videoFormat.AutomaticEnabled = true;
+    videoFormat.AfdEnabled = false;
+    videoFormat.TvFormat = (HdffTvFormat_t) gHdffSetup.TvFormat;
+    videoFormat.VideoConversion = (HdffVideoConversion_t) gHdffSetup.VideoConversion;
+    mHdffCmdIf->CmdAvSetVideoFormat(0, &videoFormat);
+
+    char str[128];
+    sprintf(str, "%s: %s", tr("Video Conversion"), gHdffSetup.GetVideoConversionString());
+    mVideoConversionItem->SetText(str);
+    Display();
+}
diff -ruN vdr-1.7.23/PLUGINS/src/dvbhddevice/menu.h vdr-1.7.24/PLUGINS/src/dvbhddevice/menu.h
--- vdr-1.7.23/PLUGINS/src/dvbhddevice/menu.h	1970-01-01 01:00:00.000000000 +0100
+++ vdr-1.7.24/PLUGINS/src/dvbhddevice/menu.h	2012-02-07 20:29:05.000000000 +0100
@@ -0,0 +1,29 @@
+/*
+ * menu.h: The DVB HD Full Featured device main menu
+ *
+ * See the README file for copyright information and how to reach the author.
+ */
+
+#ifndef _HDFF_MENU_H_
+#define _HDFF_MENU_H_
+
+#include <vdr/osd.h>
+#include <vdr/plugin.h>
+
+#include "hdffcmd.h"
+
+class cHdffMenu : public cOsdMenu
+{
+private:
+    HDFF::cHdffCmdIf * mHdffCmdIf;
+
+    cOsdItem * mVideoConversionItem;
+
+    void SetVideoConversion(void);
+public:
+    cHdffMenu(HDFF::cHdffCmdIf * pHdffCmdIf);
+    virtual ~cHdffMenu();
+    virtual eOSState ProcessKey(eKeys Key);
+};
+
+#endif
